﻿using System;
using System.Linq;
using System.Linq.Expressions;
using System.Collections.Generic;

namespace Achiral.Extension
{
    public static partial class MakeWorld
    {
        public static IEnumerable<int> UpTo(this int initial, int upto)
        {
            checked
            {
                for (var i = initial; i <= upto; ++i)
                {
                    yield return i;
                }
            }
        }
        public static IEnumerable<int> DownTo(this int initial, int downto)
        {
            checked
            {
                for (var i = initial; i >= downto; --i)
                {
                    yield return i;
                }
            }
        }
        public static IEnumerable<long> UpTo(this long initial, long upto)
        {
            checked
            {
                for (var i = initial; i <= upto; ++i)
                {
                    yield return i;
                }
            }
        }
        public static IEnumerable<long> DownTo(this long initial, long downto)
        {
            checked
            {
                for (var i = initial; i >= downto; --i)
                {
                    yield return i;
                }
            }
        }
    }
}