﻿using System;
using System.Linq;
using System.Collections.Generic;

namespace Achiral
{
    using Achiral.Extension;
    public sealed partial class TupleList<TArg1, TArg2> : List<Tuple<TArg1, TArg2>>
    {
        public void Add(TArg1 arg1, TArg2 arg2)
        {
            this.Add(Make.Tuple(arg1, arg2));
        }
        public IEnumerable<TResult> Select<TResult>(Func<TArg1, TArg2, TResult> selector)
        {
            return this.Select(item => selector(item.Arg1, item.Arg2));
        }
    }

    public sealed partial class TupleList<TArg1, TArg2, TArg3> : List<Tuple<TArg1, TArg2, TArg3>>
    {
        public void Add(TArg1 arg1, TArg2 arg2, TArg3 arg3)
        {
            this.Add(Make.Tuple(arg1, arg2, arg3));
        }
        public IEnumerable<TResult> Select<TResult>(Func<TArg1, TArg2, TArg3, TResult> selector)
        {
            return this.Select(item => selector(item.Arg1, item.Arg2, item.Arg3));
        }
    }

    public sealed partial class TupleList<TArg1, TArg2, TArg3, TArg4> : List<Tuple<TArg1, TArg2, TArg3, TArg4>>
    {
        public void Add(TArg1 arg1, TArg2 arg2, TArg3 arg3, TArg4 arg4)
        {
            this.Add(Make.Tuple(arg1, arg2, arg3, arg4));
        }
        public IEnumerable<TResult> Select<TResult>(Func<TArg1, TArg2, TArg3, TArg4, TResult> selector)
        {
            return this.Select(item => selector(item.Arg1, item.Arg2, item.Arg3, item.Arg4));
        }
    }
}