﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Achiral;
using Achiral.Extension;

namespace Achiral.Test
{
    /// <summary>
    /// Summary description for TupleTest
    /// </summary>
    [TestClass]
    public class DictionaryTest
    {
        public DictionaryTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext { get; set; }

 
        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void Dictionary_ToLookupTest1()
        {
            var lookup = new Dictionary<char, IEnumerable<string>>
            {
                { 'A', new []{"Alpha", "Avalon", "Async"} },
                { 'B', new []{"Bravo", "Biz", "BeOS"} },
                { 'C', new []{"Charlie", "Cairo", "Celelon"} },
            }.ToLookup();

            Assert.IsTrue(lookup['B'].SequenceEqual(new[] { "Bravo", "Biz", "BeOS" }));
            Assert.AreEqual(0, lookup['Z'].Count());
        }

        [TestMethod]
        public void Dictionary_ToLookupTest2()
        {
            var lookup = new Dictionary<string, Func<IEnumerable<object>>>
            {
                { "Once", () => Enumerable.Repeat(new object(), 1) },
                { "Twice", () => Enumerable.Repeat(new object(), 2) },
                { "Infinite", () => Make.Repeat(new object()) },
            }.ToLookup();

            const int count = 10000;
            Assert.AreEqual(0, lookup["???"].Count());
            Assert.AreEqual(1, lookup["Once"].Count());
            Assert.AreEqual(2, lookup["Twice"].Count());
            Assert.AreEqual(count, lookup["Infinite"].Take(count).Count());
        }

    }
}
