﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Achiral;
using Achiral.Extension;

namespace Achiral.Test
{
    /// <summary>
    /// Summary description for StringTest
    /// </summary>
    [TestClass]
    public class StringTest
    {
        public StringTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void StringJoin_Test1()
        {
            var str1 = Enumerable.Range((int)'A', 5)
                                 .Select(i => ((char)i).ToString())
                                 .Join(", ");

            var str2 = "A, B, C, D, E";

            Assert.AreEqual(str1, str2);
        }

        [TestMethod]
        public void StringJoin_Test2()
        {
            var str1 = Enumerable.Range((int)'A', 5)
                                 .Select(i => ((char)i).ToString())
                                 .ToArray()
                                 .Join(", ");

            var str2 = "A, B, C, D, E";

            Assert.AreEqual(str1, str2);
        }

        [TestMethod]
        public void StringIsNullOrEmpty_Test()
        {
            Assert.AreEqual(true, (default(string)).IsNullOrEmpty());
            Assert.AreEqual(true, string.Empty.IsNullOrEmpty());
            Assert.AreEqual(true, "".IsNullOrEmpty());
            Assert.AreEqual(false, "X".IsNullOrEmpty());
        }
    }
}
