﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Achiral;
using Achiral.Extension;

namespace Achiral.Test
{
    /// <summary>
    /// Summary description for StringTest
    /// </summary>
    [TestClass]
    public class TupleTest
    {
        public TupleTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void Tuple2_Test()
        {
            var t1 = Make.Tuple(1, "One");
            var t2 = Make.Tuple(1, "One");
            var t3 = Make.Tuple(1, "One?");

            Assert.IsTrue(t1 == t2);
            Assert.IsTrue(t1 != t3);
            Assert.IsFalse(t1 == t3);

            Assert.AreEqual(t1, t2);
            Assert.AreNotEqual(t1, t3);

            Assert.AreEqual((object)t1, (object)t2);
            Assert.AreNotEqual((object)t1, (object)t3);

            Assert.IsTrue(t1.GetHashCode() == t2.GetHashCode());
            Assert.AreEqual(t1.GetHashCode(), t2.GetHashCode());

            Assert.IsTrue(t1.Select((a1, a2) => a2) == t2.Select((a1, a2) => a2));
            Assert.IsFalse(t1.Select((a1, a2) => a2) == t3.Select((a1, a2) => a2));
        }

        [TestMethod]
        public void Tuple3_Test()
        {
            var t1 = Make.Tuple(1, "One", new DateTime(1999, 12, 31));
            var t2 = Make.Tuple(1, "One", new DateTime(1999, 12, 31));
            var t3 = Make.Tuple(1, "One", new DateTime(1999, 12, 30));

            Assert.IsTrue(t1 == t2);
            Assert.IsTrue(t1 != t3);
            Assert.IsFalse(t1 == t3);

            Assert.AreEqual(t1, t2);
            Assert.AreNotEqual(t1, t3);

            Assert.AreEqual((object)t1, (object)t2);
            Assert.AreNotEqual((object)t1, (object)t3);

            Assert.IsTrue(t1.GetHashCode() == t2.GetHashCode());
            Assert.AreEqual(t1.GetHashCode(), t2.GetHashCode());

            Assert.IsTrue(t1.Select((a1, a2, a3) => a3) == t2.Select((a1, a2, a3) => a3));
            Assert.IsFalse(t1.Select((a1, a2, a3) => a3) == t3.Select((a1, a2, a3) => a3));
        }

        [TestMethod]
        public void Tuple4_Test()
        {
            var t1 = Make.Tuple(1, "One", new DateTime(1999, 12, 31), DayOfWeek.Monday);
            var t2 = Make.Tuple(1, "One", new DateTime(1999, 12, 31), DayOfWeek.Monday);
            var t3 = Make.Tuple(1, "One", new DateTime(1999, 12, 31), DayOfWeek.Saturday);

            Assert.IsTrue(t1 == t2);
            Assert.IsTrue(t1 != t3);
            Assert.IsFalse(t1 == t3);

            Assert.AreEqual(t1, t2);
            Assert.AreNotEqual(t1, t3);

            Assert.AreEqual((object)t1, (object)t2);
            Assert.AreNotEqual((object)t1, (object)t3);

            Assert.IsTrue(t1.GetHashCode() == t2.GetHashCode());
            Assert.AreEqual(t1.GetHashCode(), t2.GetHashCode());

            Assert.IsTrue(t1.Select((a1, a2, a3, a4) => a4) == t2.Select((a1, a2, a3, a4) => a4));
            Assert.IsFalse(t1.Select((a1, a2, a3, a4) => a4) == t3.Select((a1, a2, a3, a4) => a4));

        }
    }
}
